import 'package:example/src/ui/home/controller/home_controller.dart';
import 'package:example/src/ui/shared/default_button_widget.dart';
import 'package:example/src/ui/third/third_page.dart';
import 'package:floative/core/mixins/floative_view_mixin.dart';
import 'package:floative/logger/floative_logger.dart';
import 'package:floative/ship/ship.dart';
import 'package:flutter/material.dart';

class SecondPage extends StatefulWidget {
  @override
  _SecondPageState createState() => _SecondPageState();
}

class _SecondPageState extends State<SecondPage>
    with FloativeViewMixin<HomeController> {
  @override
  void initState() {
    super.initState();
    Ship.I.debugShowPages();
    // it must show the 'HomePage Value' in the console
    controller.debugShowValue();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(
          'Second Page',
          style: TextStyle(color: Colors.black),
        ),
        backgroundColor: Color(0xffE04E68),
        centerTitle: true,
        automaticallyImplyLeading: false,
        elevation: 0,
      ),
      backgroundColor: Color(0xffE04E68),
      body: Center(
        child: Column(
          children: [
            DefaultButton(
                text: "Previous page",
                onTap: () {
                  Ship.I.back();
                }),
            DefaultButton(
                text: "Next page",
                onTap: () {
                  Ship.I.to(page: ThirdPage());
                }),
            DefaultButton(
                text: "Show Dialog",
                onTap: () async {
                  _showDialog();
                }),
            DefaultButton(
                text: "Show Botom Sheet",
                onTap: () async {
                  _showBottomSheet();
                }),
          ],
        ),
      ),
    );
  }

  Future<void> _showDialog() async {
    var result =
        await Ship.I.showDialog(isDismissible: false, dialog: _buildDialog());

    Logger.info(result.toString());
  }

  Widget _buildDialog() {
    return Container(
      height: 300,
      child: Center(
          child: Column(
        children: [
          Text('Test Dialog'),
          DefaultButton(
            text: "close me and see the log",
            onTap: () {
              Ship.I.debugShowPages();
              Ship.I.back(
                  result: "closed dialog with "
                      "result "
                      "successfully");
            },
          )
        ],
      )),
    );
  }

  Future<void> _showBottomSheet() async {
    await Ship.I.showBottomSheet(bottomSheet: _buildBottomSheet());
  }

  Widget _buildBottomSheet() {
    return Container(
      height: 300,
      decoration: BoxDecoration(
          color: Color(0xffE04E68),
          borderRadius: BorderRadius.only(
              topLeft: Radius.circular(20), topRight: Radius.circular(20))),
      child: Center(
        child: Column(
          children: [
            Text('Drag me down'),
            DefaultButton(
              text: "Or tap me",
              onTap: () {
                Ship.I.debugShowPages();
                Ship.I.back();
              },
            )
          ],
        ),
      ),
    );
  }
}
