import '../../factory/floative_factory.dart';
import '../../intl/floative_internationalization.dart';
import '../flavor/flavor.dart';

part 'floative_impl.dart';

abstract class Floative {
  Flavor currentFlavor;

  bool enableFloativeLogs;

  FloativeFactory factory;

  FloativeIntl internationalization;

  static Floative _instance;

  /// access to the Singleton instance of Floative
  static Floative get instance {
    _instance ??= _FloativeImpl();
    return _instance;
  }

  /// Short form to access the instance of Floative
  static Floative get I => instance;

  factory Floative.newInstance() {
    return _FloativeImpl();
  }
}
