part of 'floative_factory.dart';

class _Factory<T> {
  T instance;
  InstanceFunction<T> instanceFunction;
  _FactoryType factoryType;

  _Factory({this.instanceFunction, this.factoryType}) {
    if (factoryType == _FactoryType.singleton) {
      instance = instanceFunction();
    }
  }

  T getInstance({Map<String, dynamic> args = const <String, dynamic>{}}) {
    switch (factoryType) {
      case _FactoryType.lazy:
        if (instance == null) {
          instance = instanceFunction();
        }

        if (instance is FactoryArgs && args != null && args.isNotEmpty) {
          (instance as FactoryArgs).args = (args);
        }

        return instance;
      case _FactoryType.singleton:
        if (instance is FactoryArgs && args != null && args.isNotEmpty) {
          (instance as FactoryArgs).args = (args);
        }
        return instance;
      case _FactoryType.factory:
      default:
        if (instance is FactoryArgs && args != null && args.isNotEmpty) {
          (instance as FactoryArgs).args = (args);
        }
        return instanceFunction();
    }
  }
}

enum _FactoryType { factory, singleton, lazy }

typedef InstanceFunction<T> = T Function();
