part 'factory_args.dart';
part 'factory_model.dart';
part 'floative_factory_impl.dart';
part 'helper/factory_helper.dart';

abstract class FloativeFactory {
  static FloativeFactory _instance;

  /// access to the Singleton instance of FloativeFactory
  static FloativeFactory get instance {
    _instance ??= _FloativeFactoryImpl();
    return _instance;
  }

  /// Short form to access the instance of FloativeFactory
  static FloativeFactory get I => instance;

  factory FloativeFactory.newInstance() {
    return _FloativeFactoryImpl();
  }

  T get<T>({Map<String, dynamic> args = const <String, dynamic>{}});
  void register<T>(InstanceFunction<T> instance,
      {bool overrideInstance = false, bool isLazy = false});
  void registerFactory<T>(InstanceFunction<T> instanceFunction);
  void dispose<T>();
  void reset();
}
