import 'package:flutter/material.dart';
import 'package:flutter/scheduler.dart';

import '../reactive_base.dart';

part 'reactive_widget_mixin.dart';

class Reactive extends StatefulWidget {
  final ReactiveBase element;
  final WidgetBuilder builder;

  Reactive({this.element, this.builder});

  @override
  _ReactiveState createState() => _ReactiveState();
}

class _ReactiveState extends State<Reactive> with ReactiveWidgetMixin {
  @override
  void initState() {
    super.initState();
    initReaction(widget.element);
  }

  @override
  Widget build(BuildContext context) => widget.builder(context);

  @override
  void dispose() {
    widget.element.dispose();
    super.dispose();
  }
}
