import 'package:flutter/material.dart';

import '../core/controller/floative_controller.dart';
import '../core/exception/floative_exception.dart';
import '../core/floative_base/floative.dart';
import '../ship/ship.dart';

abstract class FloativeStatelessWidget<Controller extends FloativeController>
    extends StatelessWidget {
  Controller get controller {
    var controllerInstance = Floative.I.factory.get<Controller>();
    if (controllerInstance == null) {
      throw FloativeException(
          "The controller is not registered in Floative's GetIt instance");
    } else {
      return controllerInstance;
    }
  }

  void dismissKeyboard() {
    if (Ship.I.navigationKey.currentState.focusScopeNode.canRequestFocus) {
      Ship.I.navigationKey.currentState.focusScopeNode
        ..requestFocus(FocusNode());
    }
  }

  String translate(String key) {
    return Floative.I.internationalization
        ?.of(Ship.I.currentContext)
        ?.translate(key);
  }
}
