import 'package:floative/core/annotations/floative_annotations.dart';
import 'package:flutter/material.dart';

import '../core/mixins/floative_view_mixin.dart';

@AlphaFeature()
class RootView extends StatefulWidget {
  final AppBar appBar;
  final bool dismissKeyboard;
  final Color backGroundColor;
  final Widget child;
  final bool isScrollable;

  RootView(
      {@required this.child,
      this.dismissKeyboard = true,
      this.backGroundColor = Colors.white,
      this.isScrollable = false,
      this.appBar});

  @override
  _RootViewState createState() => _RootViewState();
}

class _RootViewState extends State<RootView> with FloativeViewMixin {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: widget.appBar ??
          PreferredSize(
            preferredSize: Size.fromHeight(0.0),
            child: Container(
              width: 0,
              height: 0,
            ),
          ),
      backgroundColor: widget.backGroundColor,
      body: GestureDetector(
        onTap: () {
          if (widget.dismissKeyboard) {
            dismissKeyboard();
          }
        },
        child: SingleChildScrollView(
          physics: widget.isScrollable
              ? AlwaysScrollableScrollPhysics()
              : NeverScrollableScrollPhysics(),
          child: widget.child,
        ),
      ),
    );
  }
}
